<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\NotInStock;
use App\Models\User;

class NotInStockPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any NotInStock');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, NotInStock $notinstock): bool
    {
        return $user->checkPermissionTo('view NotInStock');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create NotInStock');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, NotInStock $notinstock): bool
    {
        return $user->checkPermissionTo('update NotInStock');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, NotInStock $notinstock): bool
    {
        return $user->checkPermissionTo('delete NotInStock');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any NotInStock');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, NotInStock $notinstock): bool
    {
        return $user->checkPermissionTo('restore NotInStock');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any NotInStock');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, NotInStock $notinstock): bool
    {
        return $user->checkPermissionTo('replicate NotInStock');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder NotInStock');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, NotInStock $notinstock): bool
    {
        return $user->checkPermissionTo('force-delete NotInStock');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any NotInStock');
    }
}
